#!/bin/sh

make all-lang || exit
mv *.prc ..
make distclean
make -C ../data all
mv ../data/*.pdb ..
make -C ../data clean

cd ../..
rm -f euro2008.src.zip || exit
zip -r euro2008.src.zip euro2004 -x "*/CVS/*" -x "*/.xvpics/*" -x "euro2008/e*"

for i in de en fr es pt pl sw ru cn cz it nl cr he jp fi tr al hu ca tc dk kr ro th; do
  rm -f euro2008.$i.zip
  if [ -f euro2008/data/fixture.$i.txt ]; then
    zip euro2008.$i.zip euro2008/{euro2008.$i.prc,euro2008DB.$i.pdb,data/fixture.$i.txt,src/euro2008.rcp,src/langs/$i.rcp,README.txt}
  else
    zip euro2008.$i.zip euro2008/{euro2008.$i.prc,euro2008DB.en.pdb,data/fixture.en.txt,src/euro2008.rcp,src/langs/$i.rcp,README.txt}
  fi
done
