#define cc_CZE 1
#define cc_POR 2
#define cc_TUR 3
#define cc_SUI 4
#define cc_CRO 5
#define cc_GER 6
#define cc_POL 7
#define cc_AUT 8
#define cc_NED 9
#define cc_ITA 10 
#define cc_FRA 11 
#define cc_ROM 12 
#define cc_SWE 13
#define cc_ESP 14
#define cc_GRE 15 
#define cc_RUS 16 
#define cc_YUG 17
#define cc_USS 18
#define cc_HUN 19
#define cc_DEN 20
#define cc_ENG 21
#define cc_BEL 22 
#define cc_IRL 23
#define cc_SCO 24 
#define cc_GUS 25 
#define cc_BUL 26 
#define cc_NOR 27
#define cc_SLO 28 
#define cc_LAT 29 

#define RES_OVERTIME 64
#define RES_PENALTIES 128

#define R_GROUP_A 1
#define R_GROUP_B 2
#define R_GROUP_C 3
#define R_GROUP_D 4
#define R_QUARTER_FINAL 16
#define R_SEMI_FINAL 17
#define R_3RD_PLACE 18
#define R_FINAL 19

struct history history[] = {
  { 20642,12, R_SEMI_FINAL,    cc_FRA,cc_YUG, 4,5 },
  { 20642,12, R_SEMI_FINAL,    cc_USS,cc_CZE, 3,0 },
  { 20645,12, R_3RD_PLACE,     cc_FRA,cc_CZE, 0,2 },
  { 20646,12, R_FINAL,         cc_USS,cc_YUG, 2|RES_OVERTIME,1 },

  { 22084,11, R_SEMI_FINAL,    cc_ESP,cc_HUN, 2|RES_OVERTIME,1 },
  { 22084,11, R_SEMI_FINAL,    cc_USS,cc_DEN, 3,0 },
  { 22087,11, R_3RD_PLACE,     cc_HUN,cc_DEN, 3|RES_OVERTIME,1 },
  { 22088,11, R_FINAL,         cc_ESP,cc_USS, 2,1 },

  { 23533,10, R_SEMI_FINAL,    cc_ITA,cc_USS, 0|RES_OVERTIME,0 },
  { 23533,10, R_SEMI_FINAL,    cc_YUG,cc_ENG, 1,0 },
  { 23536,10, R_3RD_PLACE,     cc_ENG,cc_USS, 2,0 },
  { 23533,10, R_FINAL,         cc_ITA,cc_YUG, 1|RES_OVERTIME,1 },
  { 23533,10, R_FINAL,         cc_ITA,cc_YUG, 2,0 },

  { 25003, 9, R_SEMI_FINAL,    cc_USS,cc_HUN, 1,0 },
  { 25033, 9, R_SEMI_FINAL,    cc_BEL,cc_GER, 1,2 },
  { 25036, 9, R_3RD_PLACE,     cc_BEL,cc_HUN, 2,1 },
  { 25037, 9, R_FINAL,         cc_USS,cc_GER, 0,3 },

  { 26466, 8, R_SEMI_FINAL,    cc_CZE,cc_NED, 3|RES_OVERTIME,1 },
  { 26467, 8, R_SEMI_FINAL,    cc_YUG,cc_GER, 2|RES_OVERTIME,4 },
  { 26469, 8, R_3RD_PLACE,     cc_YUG,cc_NED, 2|RES_OVERTIME,3 },
  { 26470, 8, R_FINAL,         cc_CZE,cc_GER, 5|RES_PENALTIES,3 },

  { 27922, 7, R_GROUP_A,       cc_CZE,cc_GER, 0,1 },
  { 27922, 7, R_GROUP_A,       cc_GRE,cc_NED, 0,1 },
  { 27923, 7, R_GROUP_B,       cc_BEL,cc_ENG, 1,1 },
  { 27923, 7, R_GROUP_B,       cc_ITA,cc_ESP, 0,0 },
  { 27925, 7, R_GROUP_A,       cc_NED,cc_GER, 0,1 },
  { 27925, 7, R_GROUP_A,       cc_CZE,cc_GRE, 3,1 },
  { 27926, 7, R_GROUP_B,       cc_ESP,cc_BEL, 1,2 },
  { 27926, 7, R_GROUP_B,       cc_ITA,cc_ENG, 1,0 },
  { 27928, 7, R_GROUP_A,       cc_CZE,cc_NED, 1,1 },
  { 27928, 7, R_GROUP_A,       cc_GRE,cc_GER, 0,0 },
  { 27929, 7, R_GROUP_B,       cc_ESP,cc_ENG, 1,2 },
  { 27929, 7, R_GROUP_B,       cc_ITA,cc_BEL, 0,0 },
  { 27932, 7, R_3RD_PLACE,     cc_ITA,cc_CZE, 8|RES_PENALTIES,9 },
  { 27933, 7, R_FINAL,         cc_BEL,cc_GER, 1,2 },

  { 29384, 6, R_GROUP_A,       cc_FRA,cc_DEN, 1,0 },
  { 29385, 6, R_GROUP_A,       cc_BEL,cc_YUG, 2,0 },
  { 29386, 6, R_GROUP_B,       cc_POR,cc_GER, 0,0 },
  { 29386, 6, R_GROUP_B,       cc_ROM,cc_ESP, 1,1 },
  { 29388, 6, R_GROUP_A,       cc_FRA,cc_BEL, 5,0 },
  { 29388, 6, R_GROUP_A,       cc_DEN,cc_YUG, 5,0 },
  { 29389, 6, R_GROUP_B,       cc_ROM,cc_GER, 1,2 },
  { 29389, 6, R_GROUP_B,       cc_POR,cc_ESP, 1,1 },
  { 29391, 6, R_GROUP_A,       cc_DEN,cc_BEL, 3,2 },
  { 29391, 6, R_GROUP_A,       cc_FRA,cc_YUG, 3,2 },
  { 29392, 6, R_GROUP_B,       cc_POR,cc_ROM, 1,0 },
  { 29392, 6, R_GROUP_B,       cc_ESP,cc_GER, 1,0 },
  { 29395, 6, R_SEMI_FINAL,    cc_FRA,cc_POR, 3|RES_OVERTIME,2 },
  { 29366, 6, R_SEMI_FINAL,    cc_ESP,cc_DEN, 5|RES_PENALTIES,4 },
  { 29369, 6, R_FINAL,         cc_FRA,cc_ESP, 2,0 },

  { 30843, 5, R_GROUP_A,       cc_GER,cc_ITA, 1,1 },
  { 30844, 5, R_GROUP_A,       cc_DEN,cc_ESP, 2,3 },
  { 30845, 5, R_GROUP_B,       cc_ENG,cc_IRL, 0,1 },
  { 30845, 5, R_GROUP_B,       cc_NED,cc_USS, 0,1 },
  { 30847, 5, R_GROUP_A,       cc_GER,cc_DEN, 2,0 },
  { 30847, 5, R_GROUP_A,       cc_ITA,cc_ESP, 1,0 },
  { 30848, 5, R_GROUP_B,       cc_ENG,cc_NED, 1,3 },
  { 30848, 5, R_GROUP_B,       cc_IRL,cc_USS, 1,1 },
  { 30850, 5, R_GROUP_A,       cc_ITA,cc_DEN, 2,0 },
  { 30850, 5, R_GROUP_A,       cc_GER,cc_ESP, 2,0 },
  { 30851, 5, R_GROUP_B,       cc_IRL,cc_NED, 0,1 },
  { 30851, 5, R_GROUP_B,       cc_ENG,cc_USS, 1,3 },
  { 30854, 5, R_SEMI_FINAL,    cc_GER,cc_NED, 1,2 },
  { 30855, 5, R_SEMI_FINAL,    cc_USS,cc_ITA, 2,0 },
  { 30858, 5, R_FINAL,         cc_NED,cc_USS, 2,0 },

  { 32304, 4, R_GROUP_A,       cc_SWE,cc_FRA, 1,1 },
  { 32305, 4, R_GROUP_A,       cc_DEN,cc_ENG, 0,0 },
  { 32306, 4, R_GROUP_B,       cc_NED,cc_SCO, 1,0 },
  { 32306, 4, R_GROUP_B,       cc_GUS,cc_GER, 1,1 },
  { 32308, 4, R_GROUP_A,       cc_FRA,cc_ENG, 0,0 },
  { 32308, 4, R_GROUP_A,       cc_SWE,cc_DEN, 1,0 },
  { 32309, 4, R_GROUP_B,       cc_SCO,cc_GER, 0,2 },
  { 32309, 4, R_GROUP_B,       cc_NED,cc_GUS, 0,0 },
  { 32311, 4, R_GROUP_A,       cc_FRA,cc_DEN, 1,2 },
  { 32311, 4, R_GROUP_A,       cc_SWE,cc_ENG, 2,1 },
  { 32312, 4, R_GROUP_B,       cc_SCO,cc_GUS, 3,0 },
  { 32312, 4, R_GROUP_B,       cc_NED,cc_GER, 3,1 },
  { 32315, 4, R_SEMI_FINAL,    cc_SWE,cc_GER, 2,3 },
  { 32317, 4, R_SEMI_FINAL,    cc_NED,cc_DEN, 4|RES_PENALTIES,5 },
  { 32321, 4, R_FINAL,         cc_DEN,cc_GER, 2,0 },

  { 33763, 3, R_GROUP_A,       cc_ENG,cc_SUI, 1,1 },
  { 33764, 3, R_GROUP_B,       cc_ESP,cc_BUL, 1,1 },
  { 33764, 3, R_GROUP_C,       cc_CZE,cc_GER, 0,2 },
  { 33764, 3, R_GROUP_D,       cc_DEN,cc_POR, 1,1 },
  { 33765, 3, R_GROUP_A,       cc_NED,cc_SCO, 0,0 },
  { 33765, 3, R_GROUP_B,       cc_ROM,cc_FRA, 0,1 },
  { 33766, 3, R_GROUP_C,       cc_ITA,cc_RUS, 2,1 },
  { 33766, 3, R_GROUP_D,       cc_TUR,cc_CRO, 0,1 },
  { 33768, 3, R_GROUP_A,       cc_SUI,cc_NED, 0,2 },
  { 33768, 3, R_GROUP_B,       cc_BUL,cc_ROM, 1,0 },
  { 33769, 3, R_GROUP_C,       cc_CZE,cc_ITA, 2,1 },
  { 33769, 3, R_GROUP_D,       cc_POR,cc_TUR, 1,0 },
  { 33770, 3, R_GROUP_A,       cc_SCO,cc_ENG, 0,2 },
  { 33770, 3, R_GROUP_B,       cc_FRA,cc_ESP, 1,1 },
  { 33771, 3, R_GROUP_C,       cc_RUS,cc_GER, 0,3 },
  { 33771, 3, R_GROUP_D,       cc_CRO,cc_DEN, 3,0 },
  { 33773, 3, R_GROUP_A,       cc_NED,cc_ENG, 1,4 },
  { 33773, 3, R_GROUP_A,       cc_SCO,cc_SUI, 1,0 },
  { 33773, 3, R_GROUP_B,       cc_FRA,cc_BUL, 3,1 },
  { 33773, 3, R_GROUP_B,       cc_ROM,cc_ESP, 1,2 },
  { 33774, 3, R_GROUP_C,       cc_ITA,cc_GER, 0,0 },
  { 33774, 3, R_GROUP_C,       cc_RUS,cc_CZE, 3,3 },
  { 33774, 3, R_GROUP_D,       cc_CRO,cc_POR, 0,3 },
  { 33774, 3, R_GROUP_D,       cc_TUR,cc_DEN, 0,3 },
  { 33777, 3, R_QUARTER_FINAL, cc_ENG,cc_ESP, 4|RES_PENALTIES,2 },
  { 33777, 3, R_QUARTER_FINAL, cc_FRA,cc_NED, 5|RES_PENALTIES,4 },
  { 33778, 3, R_QUARTER_FINAL, cc_CRO,cc_GER, 1,2 },
  { 33778, 3, R_QUARTER_FINAL, cc_CZE,cc_POR, 1,0 },
  { 33781, 3, R_SEMI_FINAL,    cc_CZE,cc_FRA, 6|RES_PENALTIES,5 },
  { 33781, 3, R_SEMI_FINAL,    cc_ENG,cc_GER, 5|RES_PENALTIES,6 },
  { 33785, 3, R_FINAL,         cc_CZE,cc_GER, 1|RES_OVERTIME,2 },

  { 35226, 2, R_GROUP_B,       cc_BEL,cc_SWE, 2,1 },
  { 35227, 2, R_GROUP_B,       cc_TUR,cc_ITA, 1,2 },
  { 35227, 2, R_GROUP_D,       cc_FRA,cc_DEN, 3,0 },
  { 35227, 2, R_GROUP_D,       cc_NED,cc_CZE, 1,0 },
  { 35228, 2, R_GROUP_A,       cc_GER,cc_ROM, 1,1 },
  { 35228, 2, R_GROUP_A,       cc_POR,cc_ENG, 3,2 },
  { 35229, 2, R_GROUP_C,       cc_ESP,cc_NOR, 0,1 },
  { 35229, 2, R_GROUP_C,       cc_YUG,cc_SLO, 3,3 },
  { 35230, 2, R_GROUP_B,       cc_ITA,cc_BEL, 2,0 },
  { 35231, 2, R_GROUP_B,       cc_SWE,cc_TUR, 0,0 },
  { 35232, 2, R_GROUP_D,       cc_CZE,cc_FRA, 1,2 },
  { 35232, 2, R_GROUP_D,       cc_DEN,cc_NED, 0,3 },
  { 35233, 2, R_GROUP_A,       cc_ENG,cc_GER, 1,0 }, 
  { 35233, 2, R_GROUP_A,       cc_ROM,cc_POR, 0,1 },
  { 35234, 2, R_GROUP_C,       cc_NOR,cc_YUG, 0,1 },
  { 35234, 2, R_GROUP_C,       cc_SLO,cc_ESP, 1,2 },
  { 35235, 2, R_GROUP_B,       cc_ITA,cc_SWE, 2,1 },
  { 35235, 2, R_GROUP_B,       cc_TUR,cc_BEL, 2,0 },
  { 35236, 2, R_GROUP_A,       cc_ENG,cc_ROM, 2,3 }, 
  { 35236, 2, R_GROUP_A,       cc_POR,cc_GER, 3,0 }, 
  { 35237, 2, R_GROUP_C,       cc_SLO,cc_NOR, 0,0 },
  { 35237, 2, R_GROUP_C,       cc_YUG,cc_ESP, 3,4 },
  { 35237, 2, R_GROUP_D,       cc_DEN,cc_CZE, 0,2 },
  { 35237, 2, R_GROUP_D,       cc_FRA,cc_NED, 2,3 },
  { 35240, 2, R_QUARTER_FINAL, cc_ITA,cc_ROM, 2,0 },
  { 35240, 2, R_QUARTER_FINAL, cc_TUR,cc_POR, 0,2 },
  { 35241, 2, R_QUARTER_FINAL, cc_ESP,cc_FRA, 1,2 },
  { 35241, 2, R_QUARTER_FINAL, cc_NED,cc_YUG, 6,1 },
  { 35244, 2, R_SEMI_FINAL,    cc_POR,cc_FRA, 1|RES_OVERTIME,2 },
  { 35245, 2, R_SEMI_FINAL,    cc_ITA,cc_NED, 3|RES_PENALTIES,1 },
  { 35248, 2, R_FINAL,         cc_FRA,cc_ITA, 2|RES_OVERTIME,1 },

  { 36689, 1, R_GROUP_A,       cc_ESP,cc_RUS, 1,0 },
  { 36689, 1, R_GROUP_A,       cc_POR,cc_GRE, 1,2 },
  { 36690, 1, R_GROUP_B,       cc_FRA,cc_ENG, 2,1 },
  { 36690, 1, R_GROUP_B,       cc_SUI,cc_CRO, 0,0 },
  { 36691, 1, R_GROUP_C,       cc_DEN,cc_ITA, 0,0 },
  { 36691, 1, R_GROUP_C,       cc_SWE,cc_BUL, 5,0 },
  { 36692, 1, R_GROUP_D,       cc_CZE,cc_LAT, 2,1 },
  { 36692, 1, R_GROUP_D,       cc_GER,cc_NED, 1,1 },
  { 36693, 1, R_GROUP_A,       cc_GRE,cc_ESP, 1,1 },
  { 36693, 1, R_GROUP_A,       cc_RUS,cc_POR, 0,2 },
  { 36694, 1, R_GROUP_B,       cc_CRO,cc_FRA, 2,2 },
  { 36694, 1, R_GROUP_B,       cc_ENG,cc_SUI, 3,0 },
  { 36695, 1, R_GROUP_C,       cc_BUL,cc_DEN, 0,2 },
  { 36695, 1, R_GROUP_C,       cc_ITA,cc_SWE, 1,1 },
  { 36696, 1, R_GROUP_D,       cc_LAT,cc_GER, 0,0 },
  { 36696, 1, R_GROUP_D,       cc_NED,cc_CZE, 2,3 },
  { 36697, 1, R_GROUP_A,       cc_ESP,cc_POR, 0,1 },
  { 36697, 1, R_GROUP_A,       cc_RUS,cc_GRE, 2,1 },
  { 36698, 1, R_GROUP_B,       cc_CRO,cc_ENG, 2,4 },
  { 36698, 1, R_GROUP_B,       cc_SUI,cc_FRA, 1,3 },
  { 36699, 1, R_GROUP_C,       cc_DEN,cc_SWE, 2,2 },
  { 36699, 1, R_GROUP_C,       cc_ITA,cc_BUL, 2,1 },
  { 37000, 1, R_GROUP_D,       cc_GER,cc_CZE, 1,2 },
  { 37000, 1, R_GROUP_D,       cc_NED,cc_LAT, 3,0 },
  { 37701, 1, R_QUARTER_FINAL, cc_POR,cc_ENG, 6|RES_PENALTIES,5 },
  { 37702, 1, R_QUARTER_FINAL, cc_FRA,cc_GRE, 0,1 },
  { 37703, 1, R_QUARTER_FINAL, cc_SWE,cc_NED, 4|RES_PENALTIES,5 },
  { 37704, 1, R_QUARTER_FINAL, cc_CZE,cc_DEN, 3,0 },
  { 37707, 1, R_SEMI_FINAL,    cc_POR,cc_NED, 2,1 },
  { 37708, 1, R_SEMI_FINAL,    cc_GRE,cc_CZE, 1|RES_OVERTIME,0 },
  { 37711, 1, R_FINAL,         cc_POR,cc_GRE, 0,1 },

};

